//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package objects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewObjectsClassDeleteParams creates a new ObjectsClassDeleteParams object
// with the default values initialized.
func NewObjectsClassDeleteParams() *ObjectsClassDeleteParams {
	var ()
	return &ObjectsClassDeleteParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewObjectsClassDeleteParamsWithTimeout creates a new ObjectsClassDeleteParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewObjectsClassDeleteParamsWithTimeout(timeout time.Duration) *ObjectsClassDeleteParams {
	var ()
	return &ObjectsClassDeleteParams{

		timeout: timeout,
	}
}

// NewObjectsClassDeleteParamsWithContext creates a new ObjectsClassDeleteParams object
// with the default values initialized, and the ability to set a context for a request
func NewObjectsClassDeleteParamsWithContext(ctx context.Context) *ObjectsClassDeleteParams {
	var ()
	return &ObjectsClassDeleteParams{

		Context: ctx,
	}
}

// NewObjectsClassDeleteParamsWithHTTPClient creates a new ObjectsClassDeleteParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewObjectsClassDeleteParamsWithHTTPClient(client *http.Client) *ObjectsClassDeleteParams {
	var ()
	return &ObjectsClassDeleteParams{
		HTTPClient: client,
	}
}

/*ObjectsClassDeleteParams contains all the parameters to send to the API endpoint
for the objects class delete operation typically these are written to a http.Request
*/
type ObjectsClassDeleteParams struct {

	/*ClassName*/
	ClassName string
	/*ID
	  Unique ID of the Object.

	*/
	ID strfmt.UUID

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the objects class delete params
func (o *ObjectsClassDeleteParams) WithTimeout(timeout time.Duration) *ObjectsClassDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the objects class delete params
func (o *ObjectsClassDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the objects class delete params
func (o *ObjectsClassDeleteParams) WithContext(ctx context.Context) *ObjectsClassDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the objects class delete params
func (o *ObjectsClassDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the objects class delete params
func (o *ObjectsClassDeleteParams) WithHTTPClient(client *http.Client) *ObjectsClassDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the objects class delete params
func (o *ObjectsClassDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClassName adds the className to the objects class delete params
func (o *ObjectsClassDeleteParams) WithClassName(className string) *ObjectsClassDeleteParams {
	o.SetClassName(className)
	return o
}

// SetClassName adds the className to the objects class delete params
func (o *ObjectsClassDeleteParams) SetClassName(className string) {
	o.ClassName = className
}

// WithID adds the id to the objects class delete params
func (o *ObjectsClassDeleteParams) WithID(id strfmt.UUID) *ObjectsClassDeleteParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the objects class delete params
func (o *ObjectsClassDeleteParams) SetID(id strfmt.UUID) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ObjectsClassDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param className
	if err := r.SetPathParam("className", o.ClassName); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID.String()); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
